<?php
namespace FM\Factory;

use Doctrine\ORM\EntityManager;

class GLocaisFactory
{
    
    protected $connection;
    
    public function __construct(EntityManager $entityManager) {
        
        $this->connection = $entityManager->getConnection();
    }
   
    public function getFactoryUnities($params) {
        $sql = "SELECT NMLOCALCLIENTE, NRLOCALCLIENTE, NVL(DSCODIGOLOCALCLI,' ') AS DSCODIGOLOCALCLI, DSCORIDLOCAL, NRTIPOLOCALCLI, CDCLIENTE, NRLOCALCLIENTEPAI, NRCHECKLISTPADR, NRSETOR, NMABREVLOCALCLI
                  FROM FCM_LOCALCLI
                 WHERE NRLOCALCLIENTEPAI IS NULL".$params;
        
        $std = $this->connection->prepare($sql);
        
        //Talvez depois testa comentar essa linha caso de erro
        $std->execute();
        return $std->fetchAll();
    }
    
    public function getFactoryLocal($params) {
        $sql = "SELECT NMLOCALCLIENTE, NRLOCALCLIENTE, DSCODIGOLOCALCLI, NRLOCALCLIENTEPAI
                 FROM FCM_LOCALCLI
                WHERE NRLOCALCLIENTEPAI = :NRLOCALCLIENTEPAI";
        
        $std = $this->connection->prepare($sql);
        
        //Talvez depois testa comentar essa linha caso de erro
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function getFactoryLocalType($params) {
        $sql = "SELECT NMTIPOLOCALCLI, NRTIPOLOCALCLI, IDTIPOLOCALCLI, CASE IDTIPOLOCALCLI 
                       WHEN '1' THEN 'Agrupamento Completo'
                       WHEN '2' THEN 'Agrupamento Simples'
                       WHEN '3' THEN 'Local de Atendimento'
                       ELSE NULL END AS TIPOLOCAL
                    FROM FCM_TIPOLOCALCLI ".$params." ORDER BY IDTIPOLOCALCLI ASC";
        
        $std = $this->connection->prepare($sql);
        
        //Talvez depois testa comentar essa linha caso de erro
        $std->execute();
        return $std->fetchAll();
    }
    
    // Verifica se o local está em uso na tabela de tarefas
    public function validLocationTask($locationId) {
        $sql = "SELECT COUNT (*) AS VALIDA
                    FROM FCM_CHECKLISTAGEND
                 WHERE NRLOCALCLIENTE = {$locationId}";
        
        $std = $this->connection->prepare($sql);
        
        $std->execute();
        return $std->fetchAll();
    }
    
    // Verifica se o local está em uso na tabela de vistorias
    public function validLocationInspection($locationId) {
        $sql = "SELECT COUNT (*) AS VALIDA
                    FROM FCM_GERENCIAMENTOCHK
                 WHERE NRLOCALCLIENTE = {$locationId}";
        
        $std = $this->connection->prepare($sql);
        
        $std->execute();
        return $std->fetchAll();
    }
    
    // Deleta locais de acordo com os ids recebidos;
    public function deleteLocation($locationsIdsString) {
        //Deleta a relação da tabela localcli com o checklist Padrão
        $sql = "DELETE FROM FCM_RELACLOCALCHK
                 WHERE NRLOCALCLIENTE IN ({$locationsIdsString})";
        
        $std = $this->connection->prepare($sql);
        
        $std->execute();
        
        // Deleta o local
        $sql = "DELETE FROM FCM_LOCALCLI
                 WHERE NRLOCALCLIENTE IN ({$locationsIdsString})";
        
        $std = $this->connection->prepare($sql);
        
        $std->execute();
    }
}
?>