<?php

namespace FM\Service;

use FM\Factory\ImpactoManutFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Doctrine\ORM\EntityManager;

class ImpactoManutService {

    protected $ImpactoManutFactory;
    protected $Environment;
    protected $newCode;

    public function __construct (EntityManager $entityManager, ImpactoManutFactory $ImpactoManutFactory, Environment $Environment, NewCode $newCode) {
        $this->ImpactoManutFactory = $ImpactoManutFactory;
        $this->connection          = $entityManager->getConnection();
        $this->Environment         = $Environment;
        $this->newCode             = $newCode;
    }

    public function inserirImpacto($parametros) {
        $NRORG =  $this->Environment->getNrOrg();
        $this->connection->beginTransaction();

        try {

            $NRIMPACTOMANUT = $this->newCode->getCodeByTableName("FCM_IMPACTOMANUT", $NRORG, 1, 10, true);

            $parametros = array(
                "NRIMPACTOMANUT"        => $NRIMPACTOMANUT,
                "NMIMPACTOMANUT"        => $parametros['NMIMPACTO'],
                "NRPRIORIDADEMANUTPADR" => $parametros['NRPRIORIDADE']
            );

            $this->ImpactoManutFactory->inserirImpacto($parametros);

            $this->connection->commit();
            $response = 'OK';

        } catch(\Exception $e) {
           $this->connection->rollback();
           $response = ($e->getMessage());
        }
        return $response;
    }

    public function getInformacoesImpacto() {

        $infoImp = $this->ImpactoManutFactory->getInformacoesImpacto();
        return $infoImp;
    }
}

?>