/**
 * Detalha dados de horas vendidas, trabalhadas, faturadas e no faturadas
 * a partir das propostas e CDAs lanados pelos colaboradores.
 *
 * @author Ederson Melquades da Cunha <ederson@teknisa.com>
 */

CREATE VIEW ETL_SERVPRESTDRILL AS
   (SELECT NVL(PA.CDGERENTEIMPCLI, 'XXXXXXXXXXXX') AS CDGERENTEIMPCLI, 
           SE.CDCLIENTE, 
           OP.CDOPERADOR AS CDOPERFUNC,
           CS.CDTIPOSERV, 
           NVL(PRO.CDPROJETO, 'SEM PROJETO') CDPROJETO, 
           NVL(OPG.NMOPERADOR, 'SEM GERENTE') AS NMGERENTEPRJ,
           LTRIM(PR.DSREFEPROPOSFAS || ' ' || CS.NRPROPOSFAS || '-' || CS.NRVERPROPFAS) AS DSPROPOSETLSERV,
           TO_CHAR(SE.DTSERVPREST, 'YYYY') DTANOCSA, -- DIMENSO 00025 ANO (YYYY)
           CASE WHEN (TO_CHAR(SE.DTSERVPREST, 'DD') >= '21') AND (TO_CHAR(SE.DTSERVPREST, 'DD') <= '31') THEN TO_CHAR(TO_DATE('21/' || TO_CHAR(SE.DTSERVPREST, 'MM/YYYY')), 'DD/MM/YYYY') || ' a ' || TO_CHAR(ADD_MONTHS(TO_DATE('20/' || TO_CHAR(SE.DTSERVPREST, 'MM/YYYY')), 1), 'DD/MM/YYYY')
                ELSE TO_CHAR(ADD_MONTHS(TO_DATE('21/' || TO_CHAR(SE.DTSERVPREST, 'MM/YYYY')), -1), 'DD/MM/YYYY') || ' a ' || TO_CHAR(TO_DATE('20/' || TO_CHAR(SE.DTSERVPREST, 'MM/YYYY')), 'DD/MM/YYYY')
            END AS DSPERIODOCSA, -- Dimenso 00316 Perodo           
           CASE WHEN (CS.QTSERVCONT IS NULL) OR (CS.QTSERVCONT > 100000) THEN 0 ELSE CS.QTSERVCONT END AS QTHRVENDETLSERV,
           TO_CHAR(SE.DTSERVPREST, 'dy dd/mm/yyyy') AS DTSERVPREST,
           HORACHAR_HORADEC(QTHRTOTAL) AS QTHRTRABETLSERV,
           NVL(QTHRAPROFATU,0) AS QTHRFATUETLSERV,
           CASE WHEN (HORACHAR_HORADEC(QTHRTOTAL) - NVL(QTHRAPROFATU,0)) < 0 THEN 0 ELSE (HORACHAR_HORADEC(QTHRTOTAL) - NVL(QTHRAPROFATU,0)) END AS QTHRNFATETLSERV,
           HORACHAR_HORADEC(NVL(SE.QTHRDESLOCAMENTOFAT, '0000')) AS QTHRDESLOCFATETLSERV
      FROM PROPOSTAFAS PR, PARCLIEFAS PA, OPERADOR OP, OPERADOR OPG, PROJETO PRO, CONTRATOSERV CS, SERVPREST SE
     WHERE SE.CDCLIENTE NOT IN ('J26269316000177',
                                'I00000000000132153215',
                                'J06240810000100',
                                'J06348006000130',
                                'F03924269602',
                                'J05118011000194',
                                'I00000000000000067084',
                                'I06917855626')
       AND CS.NRPROPOSFAS = SE.NRPROPOSFAS
       AND CS.NRVERPROPFAS = SE.NRVERPROPFAS
       AND CS.CDTIPOSERV = SE.CDTIPOSERV
       AND CS.NRSERVCONT = SE.NRSERVCONT
       AND OP.CDEMPRESA = SE.CDEMPRESA
       AND OP.CDFUNC = SE.CDFUNC
       AND PA.CDCLIENTE (+) = SE.CDCLIENTE
       AND PA.IDTPFATUCLIE (+) = '5'
       AND PR.NRPROPOSFAS = SE.NRPROPOSFAS
       AND PR.NRVERPROPFAS = SE.NRVERPROPFAS
       AND PRO.CDPROJETO (+) = SE.CDPROJETO
       AND OPG.CDOPERADOR (+) = PRO.CDOPERESPRJ)
/

-- VERSAO --
BEGIN ATUVEROBJ('ETL_SERVPRESTDRILL','5.50.XXX'); END;
/
